﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace PoEcoDB
{
    internal class Program
    {
        public static string version = "1.0.0";
        static void Main(string[] args)
        {
            // Splash
            Message.Splash("PoEcoDB", "mikx");
            // Setup the base ecosystem
            if (!Directory.Exists(@"data")) { Directory.CreateDirectory(@"data"); }
            // Args Manager
            if (args.Contains("--genclass"))
            {
                Message.CMW("Getting the latest PoB Community LUA...", true, 1);
                Web.PoBLua.GetLatestLUA();
                Message.CMW("Generating the latest classes and bases...", true, 1);
                DB.ClassGen. ();
                Message.CMW("Generation done.", true, 2);
                return;
            }
            if (args.Contains("--user"))
            {
                if (args.Length > 1)
                {
                    string user = args[1];
                    Message.CMW($"User \"{user}\" processing...", true, 1);
                    Message.CMW($"Checking the database for user \"{user}\"...", true, 1);
                    if (DB.User.CheckUserExists(user))
                    {
                        var uid = DB.User.GetUserID(user);
                        Message.CMW($"User \"{user}\" exists with ID \"{uid}\".", true, 2);
                        string sessionid = DB.User.GetUserSessionID(user);
                        int tabindex = 0;
                        if (args.Contains("--tabindex"))
                        {
                            tabindex = Convert.ToInt32(args[3]);
                        } else
                        {
                            tabindex = DB.User.GetUserTabIndex(user);
                        }                       
                        Web.Stash.DownloadStash(sessionid, $"https://www.pathofexile.com/character-window/get-stash-items?league={JSON.Settings.GetLeague()}&tabs=1&tabIndex={tabindex}&accountName={user}", $@"data\stash\{user}.json");
                        JSON.Stash.GenItemTable(user);
                    } else
                    {
                        Message.CMW($"User \"{ user}\" doesn't exists.", true, 3);
                    }
                } else
                {
                    Message.CMW($"You must specify a user with this argument.", true, 3);
                    Message.CMW($"Exemple: --user bob", true, 3);
                    Message.CMW($"Press any key to quit...", true, 1);
                    Console.ReadKey();
                    return;
                }               
                return;
            }
        }
    }
}
